local mapMod = foundation.createMod();

-- registering map files
mapMod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")
mapMod:registerAssetId("maps/tree_density_map1.png", "TREE_DENSITY_MAP1")
mapMod:registerAssetId("maps/tree_density_map2.png", "TREE_DENSITY_MAP2")
mapMod:registerAssetId("maps/tree_density_map3.png", "TREE_DENSITY_MAP3")

-- register custom map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "GRANDLOW_ID",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -5,
	MaxHeight = 95,
	VillagePathList = {
		{
			Entrance = { 1020, 0, 123 },
			Exit = { 1020, 0, 118 },
		},
		{
			Entrance = { 5, 0, 133 },
			Exit = { 7, 0, 133 },
		}
	},
	SpawnList = {
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 410 , 35 , 973 },
			Orientation = { 0.0, -180.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 370 , 36 , 958 },
			Orientation = { 0.0, 160.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 342 , 38 , 928 },
			Orientation = { 0.0, 100.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 335 , 37 , 883 },
			Orientation = { 0.0, 80.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 5
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 345 , 23 , 843 },
			Orientation = { 0.0, 70.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 6
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 371 , 24 , 913 },
			Orientation = { 0.0, 120.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 7
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 420 , 23 , 943 },
			Orientation = { 0.0, 160.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 8
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 376 , 30 , 857 },
			Orientation = { 0.0, 80.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 9
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 530 , 2 , 803 },
			Orientation = { 0.0, -20.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 10
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 560 , 3 , 833 },
			Orientation = { 0.0, -90.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 11
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 560 , 4 , 883 },
			Orientation = { 0.0, -110.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 12
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 290 , 22 , 803 },
			Orientation = { 0.0, -180.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 13
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 260 , 24 , 763 },
			Orientation = { 0.0, 45.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 14
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 258 , 25 , 793 },
			Orientation = { 0.0, 135.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 15
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 120 , 4 , 163 },
			Orientation = { 0.0, -180.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 16
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 130 , 5 , 163 },
			Orientation = { 0.0, -180.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 17
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 140 , 10 , 163 },
			Orientation = { 0.0, -180.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 18
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 390 , 23 , 936 },
			Orientation = { 0.0, 150.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 19
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 365 , 29 , 883 },
			Orientation = { 0.0, 80.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 20
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 110 , 2 , 163 },
			Orientation = { 0.0, -180.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		}
	},
	DensitySpawnList = {
			{
			-- creating Tree Density Map1
			DensityMap = "TREE_DENSITY_MAP1",
			Density = 0.91,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_OAK" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 1.2,
							Max = 1.8
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_OAK" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 1.0,
							Max = 1.5
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_SYCAMORE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.2,1 },
							Max = { 0.8,0.8,0.4,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_SYCAMORE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.9,0.8,0.1,1 },
							Max = { 1.0,0.9,0.5,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map2
			DensityMap = "TREE_DENSITY_MAP2",
			Density = 0.8,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_POPLAR" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 1.2,
							Max = 1.8
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_POPLAR" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 1.0,
							Max = 1.5
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1,1,1,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_POPLAR" },
						RandomWeight = 5.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map3
			DensityMap = "TREE_DENSITY_MAP3",
			Density = 0.8,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 1.2,
							Max = 1.8
					},
						ColorRange = {
							Min = { 0.3450927734375,0.447052001953125,0.352935791015625,1 },
							Max = { 0.1999969482421875,0.258819580078125,0.20391845703125,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 1.0,
							Max = 1.5
					},
						ColorRange = {
							Min = { 0.1058807373046875,0.6941070556640625,0.3725433349609375,1 },
							Max = { 0.04705810546875,0.321563720703125,0.17254638671875,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 5.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.3568572998046875,0.7254791259765625,0.588226318359375,1 },
							Max = { 0.14117431640625,0.3333282470703125,0.2627410888671875,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.0,0.5,1.0,1 },
							Max = { 0.5,0.75,1.0,1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_BERRIES" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_ROCK" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_FISH" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})
-- This map was created with the help of the UFME
